Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.io
Class NonshareableBufferedDataInputStream

    java.lang.Object
      java.io.InputStream
          java.io.FilterInputStream
              org.ka2ddo.yaac.io.NonshareableBufferedDataInputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.DataInput

    public final class NonshareableBufferedDataInputStream

extends java.io.FilterInputStream
implements java.io.DataInput

This class is a merged copy of java.io.BufferedInputStream and java.io.DataInputStream, but without the synchronization, which restricts instances of this class to use in a single thread. Note that, because of certain optimizations performed in this code, the user should either use a buffer size greater than 65536 or ensure that all strings read with the readUTF() method are shorter than the buffer size. Also, this class should not be used on streams associated with nonblocking files, such as sockets set O_NONBLOCK.

See Also:
  `BufferedInputStream`, `DataInputStream`

Field Summary

Fields inherited from class java.io.FilterInputStream
`in`

Constructor Summary
`NonshareableBufferedDataInputStream(java.io.InputStream in)` Creates a `BufferedInputStream` and saves its argument, the input stream `in`, for later use.
`NonshareableBufferedDataInputStream(java.io.InputStream in, byte[] buf)` Creates a new buffered output stream to write data to the specified underlying output stream with the specified buffer.
`NonshareableBufferedDataInputStream(java.io.InputStream in, int size)` Creates a `NonshareableBufferedInputStream` with the specified buffer size, and saves its argument, the input stream `in`, for later use.

Method Summary
`int` | `available()` Returns an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking by the next invocation of a method for this input stream.
`void` | `close()` Closes this input stream and releases any system resources associated with the stream.
`void` | `mark(int readlimit)` See the general contract of the `mark` method of `InputStream`.
`boolean` | `markSupported()` Tests if this input stream supports the `mark` and `reset` methods.
`int` | `read()` See the general contract of the `read` method of `InputStream`.
`int` | `read(byte[] b)` Reads some number of bytes from the contained input stream and stores them into the buffer array `b`.
`int` | `read(byte[] b, int off, int len)` Reads bytes from this byte-input stream into the specified byte array, starting at the given offset.
`boolean` | `readBoolean()` See the general contract of the `readBoolean` method of `DataInput`.
`byte` | `readByte()` See the general contract of the `readByte` method of `DataInput`.
`char` | `readChar()` See the general contract of the `readChar` method of `DataInput`.
`double` | `readDouble()` See the general contract of the `readDouble` method of `DataInput`.
`float` | `readFloat()` See the general contract of the `readFloat` method of `DataInput`.
`void` | `readFully(byte[] b)` See the general contract of the `readFully` method of `DataInput`.
`void` | `readFully(byte[] b, int off, int len)` See the general contract of the `readFully` method of `DataInput`.
`int` | `readInt()` See the general contract of the `readInt` method of `DataInput`.
`java.lang.String` | `readLine()` See the general contract of the `readLine` method of `DataInput`.
`long` | `readLong()` See the general contract of the `readLong` method of `DataInput`.
`short` | `readShort()` See the general contract of the `readShort` method of `DataInput`.
`int` | `readUnsignedByte()` See the general contract of the `readUnsignedByte` method of `DataInput`.
`int` | `readUnsignedShort()` See the general contract of the `readUnsignedShort` method of `DataInput`.
`java.lang.String` | `readUTF()` See the general contract of the `readUTF` method of `DataInput`.
`void` | `reset()` See the general contract of the `reset` method of `InputStream`.
`long` | `skip(long n)` See the general contract of the `skip` method of `InputStream`.
`int` | `skipBytes(int n)` See the general contract of the `skipBytes` method of `DataInput`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NonshareableBufferedDataInputStream

    public NonshareableBufferedDataInputStream(java.io.InputStream in)

  Creates a `BufferedInputStream` and saves its argument, the input stream `in`, for later use. An internal buffer array is created and stored in `buf`.

  Parameters:
    `in` - the underlying input stream.

### NonshareableBufferedDataInputStream

    public NonshareableBufferedDataInputStream(java.io.InputStream in,
                                               int size)

  Creates a `NonshareableBufferedInputStream` with the specified buffer size, and saves its argument, the input stream `in`, for later use. An internal buffer array of length `size` is created and stored in `buf`.

  Parameters:
    `in` - the underlying input stream.
    `size` - the buffer size (minimum size 8 bytes).
  Throws:
    `java.lang.IllegalArgumentException` - if size < 8.

### NonshareableBufferedDataInputStream

    public NonshareableBufferedDataInputStream(java.io.InputStream in,
                                               byte[] buf)
                                        throws java.lang.IllegalArgumentException,
                                               java.io.IOException

  Creates a new buffered output stream to write data to the specified underlying output stream with the specified buffer. Note this constructor can only be used with underlying streams that are ready to be read at this time of this constructor call.

  Parameters:
    `in` - the underlying input stream.
    `buf` - the buffer to use (minimum size 8 bytes)
  Throws:
    `java.lang.IllegalArgumentException` - if size < 8.
    `java.io.IOException` - if underlying stream cannot be read immediately

Method Detail

### read

    public int read()
             throws java.io.IOException

  See the general contract of the `read` method of `InputStream`.

  Overrides:
    `read` in class `java.io.FilterInputStream`
  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `java.io.IOException` - if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.
  See Also:
    `FilterInputStream.in`

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws java.io.IOException

  Reads bytes from this byte-input stream into the specified byte array, starting at the given offset.

  This method implements the general contract of the corresponding ``read`` method of the ``InputStream`` class. As an additional convenience, it attempts to read as many bytes as possible by repeatedly invoking the `read` method of the underlying stream. This iterated `read` continues until one of the following conditions becomes true:

  - The specified number of bytes have been read,
  - The `read` method of the underlying stream returns `-1`, indicating end-of-file, or
  - The `available` method of the underlying stream returns zero, indicating that further input requests would block.
  If the first `read` on the underlying stream returns `-1` to indicate end-of-file then this method returns `-1`. Otherwise this method returns the number of bytes actually read.

  Subclasses of this class are encouraged, but not required, to attempt to read as many bytes as possible in the same fashion.

  Overrides:
    `read` in class `java.io.FilterInputStream`
  Parameters:
    `b` - destination buffer.
    `off` - offset at which to start storing bytes.
    `len` - maximum number of bytes to read.
  Returns:
    the number of bytes read, or `-1` if the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.

### skip

    public long skip(long n)
              throws java.io.IOException

  See the general contract of the `skip` method of `InputStream`.

  Overrides:
    `skip` in class `java.io.FilterInputStream`
  Throws:
    `java.io.IOException` - if the stream does not support seek, or if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.

### available

    public int available()
                  throws java.io.IOException

  Returns an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking by the next invocation of a method for this input stream. The next invocation might be the same thread or another thread. A single read or skip of this many bytes will not block, but may read or skip fewer bytes.

  This method returns the number of bytes remaining to be read in the buffer (`count - pos`), possibly refilling the buffer if it was empty at the time of this call. Specifically, it does _not_ try to return the total remaining bytes in the file.

  Overrides:
    `available` in class `java.io.FilterInputStream`
  Returns:
    an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking.
  Throws:
    `java.io.IOException` - if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.

### mark

    public void mark(int readlimit)

  See the general contract of the `mark` method of `InputStream`.

  Overrides:
    `mark` in class `java.io.FilterInputStream`
  Parameters:
    `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid.
  See Also:
    `reset()`

### reset

    public void reset()
               throws java.io.IOException

  See the general contract of the `reset` method of `InputStream`.

  If `markpos` is `-1` (no mark has been set or the mark has been invalidated), an `IOException` is thrown. Otherwise, `pos` is set equal to `markpos`.

  Overrides:
    `reset` in class `java.io.FilterInputStream`
  Throws:
    `java.io.IOException` - if this stream has not been marked or, if the mark has been invalidated, or the stream has been closed by invoking its `close()` method, or an I/O error occurs.
  See Also:
    `mark(int)`

### markSupported

    public boolean markSupported()

  Tests if this input stream supports the `mark` and `reset` methods. The `markSupported` method of `NonshareableBufferedDataInputStream` returns `false`.

  Overrides:
    `markSupported` in class `java.io.FilterInputStream`
  Returns:
    a `boolean` indicating if this stream type supports the `mark` and `reset` methods.
  See Also:
    `InputStream.mark(int)`, `InputStream.reset()`

### close

    public void close()
               throws java.io.IOException

  Closes this input stream and releases any system resources associated with the stream. Once the stream has been closed, further read(), available(), reset(), or skip() invocations will throw an IOException. Closing a previously closed stream has no effect.

  Specified by:
    `close` in interface `java.io.Closeable`
  Overrides:
    `close` in class `java.io.FilterInputStream`
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### read

    public final int read(byte[] b)
                   throws java.io.IOException

  Reads some number of bytes from the contained input stream and stores them into the buffer array `b`. The number of bytes actually read is returned as an integer. This method blocks until input data is available, end of file is detected, or an exception is thrown.

  If `b` is null, a `NullPointerException` is thrown. If the length of `b` is zero, then no bytes are read and `0` is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value `-1` is returned; otherwise, at least one byte is read and stored into `b`.

  The first byte read is stored into element `b[0]`, the next one into `b[1]`, and so on. The number of bytes read is, at most, equal to the length of `b`. Let `k` be the number of bytes actually read; these bytes will be stored in elements `b[0]` through `b[k-1]`, leaving elements `b[k]` through `b[b.length-1]` unaffected.

  The `read(b)` method has the same effect as:

  >      read(b, 0, b.length)

  Overrides:
    `read` in class `java.io.FilterInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if the first byte cannot be read for any reason other than end of file, the stream has been closed and the underlying input stream does not support reading after close, or another I/O error occurs.
  See Also:
    `InputStream.read(byte[], int, int)`

### readFully

    public final void readFully(byte[] b)
                         throws java.io.IOException

  See the general contract of the `readFully` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readFully` in interface `java.io.DataInput`
  Parameters:
    `b` - the buffer into which the data is read.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading all the bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readFully

    public final void readFully(byte[] b,
                                int off,
                                int len)
                         throws java.io.IOException

  See the general contract of the `readFully` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readFully` in interface `java.io.DataInput`
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the number of bytes to read.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading all the bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### skipBytes

    public final int skipBytes(int n)
                        throws java.io.IOException

  See the general contract of the `skipBytes` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `skipBytes` in interface `java.io.DataInput`
  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    `java.io.IOException` - if the contained input stream does not support seek, or the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readBoolean

    public final boolean readBoolean()
                              throws java.io.IOException

  See the general contract of the `readBoolean` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readBoolean` in interface `java.io.DataInput`
  Returns:
    the `boolean` value read.
  Throws:
    `java.io.EOFException` - if this input stream has reached the end.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readByte

    public final byte readByte()
                        throws java.io.IOException

  See the general contract of the `readByte` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readByte` in interface `java.io.DataInput`
  Returns:
    the next byte of this input stream as a signed 8-bit `byte`.
  Throws:
    `java.io.EOFException` - if this input stream has reached the end.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readUnsignedByte

    public final int readUnsignedByte()
                               throws java.io.IOException

  See the general contract of the `readUnsignedByte` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readUnsignedByte` in interface `java.io.DataInput`
  Returns:
    the next byte of this input stream, interpreted as an unsigned 8-bit number.
  Throws:
    `java.io.EOFException` - if this input stream has reached the end.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readShort

    public final short readShort()
                          throws java.io.IOException

  See the general contract of the `readShort` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readShort` in interface `java.io.DataInput`
  Returns:
    the next two bytes of this input stream, interpreted as a signed 16-bit number.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading two bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readUnsignedShort

    public final int readUnsignedShort()
                                throws java.io.IOException

  See the general contract of the `readUnsignedShort` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readUnsignedShort` in interface `java.io.DataInput`
  Returns:
    the next two bytes of this input stream, interpreted as an unsigned 16-bit integer.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading two bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readChar

    public final char readChar()
                        throws java.io.IOException

  See the general contract of the `readChar` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readChar` in interface `java.io.DataInput`
  Returns:
    the next two bytes of this input stream, interpreted as a `char`.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading two bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readInt

    public final int readInt()
                      throws java.io.IOException

  See the general contract of the `readInt` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readInt` in interface `java.io.DataInput`
  Returns:
    the next four bytes of this input stream, interpreted as an `int`.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading four bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readLong

    public final long readLong()
                        throws java.io.IOException

  See the general contract of the `readLong` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readLong` in interface `java.io.DataInput`
  Returns:
    the next eight bytes of this input stream, interpreted as a `long`.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading eight bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.

### readFloat

    public final float readFloat()
                          throws java.io.IOException

  See the general contract of the `readFloat` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readFloat` in interface `java.io.DataInput`
  Returns:
    the next four bytes of this input stream, interpreted as a `float`.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading four bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.
  See Also:
    `readInt()`, `Float.intBitsToFloat(int)`

### readDouble

    public final double readDouble()
                            throws java.io.IOException

  See the general contract of the `readDouble` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readDouble` in interface `java.io.DataInput`
  Returns:
    the next eight bytes of this input stream, interpreted as a `double`.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading eight bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.
  See Also:
    `readLong()`, `Double.longBitsToDouble(long)`

### readLine

    public final java.lang.String readLine()
                                    throws java.io.IOException

  See the general contract of the `readLine` method of `DataInput`.

  Bytes for this operation are read from the contained input stream. Note that this method only supports extended 8-bit ASCII; it does not support UTF-8 or other locale-specific character sets.

  Specified by:
    `readLine` in interface `java.io.DataInput`
  Returns:
    the next line of text from this input stream.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### readUTF

    public final java.lang.String readUTF()
                                   throws java.io.IOException

  See the general contract of the `readUTF` method of `DataInput`.

  Bytes for this operation are read from the contained input stream.

  Specified by:
    `readUTF` in interface `java.io.DataInput`
  Returns:
    a Unicode string.
  Throws:
    `java.io.EOFException` - if this input stream reaches the end before reading all the bytes.
    `java.io.IOException` - the stream has been closed and the contained input stream does not support reading after close, or another I/O error occurs.
    `java.io.UTFDataFormatException` - if the bytes do not represent a valid modified UTF-8 encoding of a string.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD